package com.eactive.eai.batch.job.jobItem.ccrs;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_CCRSF_0610 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private Properties telegramInfo;

    private final String OpCode_all_end        = "004";    //개별업무 종료

    /**
     * 생성자
     */
    public SEND_CCRSF_0610() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //(송신길이)는 TCP/IP 프로토콜에서만 사용 자기 자신 포함 안함           
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션 코드 : 회원가기관의 주전산기(또는 중계기)를 위한 트랜잭션 구분자로 “CREDITFTP”를 사용한다.
            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //시스템 명칭 : 일괄전송 업무를 타 업무와 구분하기 위하여 사용하는 부호로 “FTP”를 사용한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //회원기관코드 : 전문을 생성하여 발신하는 기관을 나타내기 위한 부호로 회원기관별로 유일하게 부여한다.(5.2 참조).
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);

            //전문코드 : 전문을 구별하기 위하여 사용하는 기호로 전문 생성기관, 이용목적 등을 포함하고 있다(3.3 참조).
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //업무구분코드 : 전문에 포함된 파일의 용도나 속성을 나타내기 위한 기호로 ‘표준보고서 양식’의 별칭을 사용한다(6.1~6.4  참조).
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //전문 생성기관 : 전문을 작성한 기관을 나타내는 기호로 신용회복위원회가 생성한 경우 “C”를, 회원기관이 생성한 전문에는 “B”를 사용한다.
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);

            //응답코드 : 전문의 처리결과를 나타내는 부호로 다음과 같이 설정한다.
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);

            // 여기부터는 개별부

            //송수신구분 : 적용업무를 구분하기 위한 기호
            //“S”: 파일송신(신용회복위원회가 회원기관에 파일을 전송)의 경우
            //“R”: 파일수신(회원기관이 신용회복위원회에 파일을 전송)
            compileField(8, getFldTrClass() , this.al_FieldProps[8]);

            //관리정보 : 전문의 기능을 나타내는 부호로 
            // 개별업무를 시작하는 경우 “001”,
            // 개별업무를 종료하는 경우 “003”,
            // 일괄전송 모든 업무를 종료하고자 하는 경우 “004”,
            // 파일 재전송을 요구하는 경우 “006”을 사용한다.
            // ※ 현재 일괄전송 시스템에서 운영하고 있는 개별업무는 회원기관업무시스템 관련업무(업무구분코드가 “FTP”) 밖에 없으며 향후 개별업무가 확장성을 고려함
            compileField(9, this.getFldOpCode(), this.al_FieldProps[9]);

            //최종 블록번호 : 지금까지 수신한 최종 블록번호를 나타내며 처음부터 받고자 하는 경우 “0000”을 사용한다.
            compileField(10, "", this.al_FieldProps[10]);

            //최종 시퀀스번호 : 해당 블록 내에서의 최종 시퀀스번호를 사용한다.
            compileField(11, "", this.al_FieldProps[11]);

            //전송 일시 : 전문을 생성한 기관(신용회복위원회 또는 회원기관)에서 전문을 전송하는 일자와 시각(YYYYMMDDHhMmSs)을 기입한다.
            //단, 회원기관이 자료 수신 시간대 이후에 미수신 자료를 신용회복위원회로부터 받고자 하는 경우에는 일자에 정상적인 전송일자(YYYYMMDD)를 기입하고 시각은 “999999”(HhMmSs)를 기입한다.
            compileField(12, TelegramKeys.getYYYYMMddHHmmss(), this.al_FieldProps[12]);
            
            //송신집계 : 개별업무 종료 및 전 업무 종료 시에만 사용하는 항목으로 송신한 파일의 수를 나타내며 기타의 경우는 “0000”을 사용한다.
            int fileCnt = 0;
            try {
				fileCnt = Integer.parseInt(batchDoc.getBatchMsg().getBody().getSendSummary());
			} catch (Exception e) {}
        	compileField(13, "" + fileCnt, this.al_FieldProps[13]);
            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        batchDoc.getBatchMsg().getBody().setBlockNum(0);
        batchDoc.getBatchMsg().getBody().setSeqNum(0);
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<8; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=8; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

//    /**
//     * return value : 0 no left data to be sent
//     *                -1 error
//     *                >0 data copied to the data field
//     *
//     * 비정형 필드인 결번확인의 데이터를 얻어낸다.
//     * 결번확인 데이터를 실어주고 결번확인 필드의 길이를 반환한다.
//     */
//    public int getInformalFieldSendData(int idx, byte[] data) {
//        try {
//            if (idx >= this.getFieldCount() ) {
//                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
//                String[] msgArgs = new String[2];
//                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//                msgArgs[1] = ""+idx;
//                String errCode = "BECEAIFJI011";
//                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//                return -1;
//            }
//            if (data.length < 8) {
//                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
//                String[] msgArgs = new String[1];
//                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//                String errCode = "BECEAIFJI014";
//                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//                return -1;
//            }
//            if ( !OpCode_all_end.equals(getFldOpCode()) ) {
//                return 0;
//            }
//
//            String summary = "01" + batchDoc.getBatchMsg().getHeader().getBizCode();
//            System.arraycopy( summary.getBytes(), 0, data, 0, 8);
//            return 8;
//        } catch (Exception ex) {
//            String[] msgArgs = new String[1];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            String errCode = "BECEAIFJI006";
//            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//            logger.error( ex.getMessage(), ex);
//            return -1;
//        }
//    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                if ( !OpCode_all_end.equals(getFldOpCode()) ) {
                    return 0;
                }
                else return 8;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(8);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(9);
    }
}